#ifndef __ADRENALIN__AREAS__HEADER__
#define __ADRENALIN__AREAS__HEADER__

#include <windows.h>
#include "Links.hpp"
#include "Common.hpp"


const
    AREA_NAME_SIZE = 32,
    AREA_DESC_SIZE = 256;


struct SLinked {
    SLink   *LinkPtr;
    int      RouteType;
    SLinked *Next;
};

struct SArea {
    char		Name[AREA_NAME_SIZE];
    char		Path[MAX_PATH];
    char		Desc[AREA_DESC_SIZE];
    int			RouteType;
    int			Priority;
    unsigned long	Group;
    int			PassThrough;
    int			VetoManualPurge;
    SLinked		*LinkedList, *LastLinked;
    int			Line;
    int			LinksChanged;
    int			Traffic;
    SArea		*Next;
};


class CAreas {
public:
    CAreas();
    ~CAreas();
    void     Add(SArea &NewArea);
    void     AutoCreate(char *NewAreaName, SLink *Creator);
    SArea   *Selected;
    int      SelectFirst();
    int      SelectNext();
    int      Select(char *AreaName);
    int      CanAccess(SLink *Link);
    SLinked* Linked(SLink *Link);
    int      Link(SLink *Link);
    int      Unlink(SLink *Link);
    int      LinksChanged();
    int      SaveToFile(char *FileName);
    void     GetNameDesc(char *NameDesc);
    int      GetRouteType(SLink *Link);
    int      UpdateDescFile(char *FileName, char *FileDesc,
                            SStringList* LDescList = NULL);
    void     ClearDescFile(char *FileName);
    int      IsValidName(char *Name);
    void     Sort();
    void     GetAreas();
private:
	SArea *AreasList, *LastArea;
	int    MaxAreaNameLen, MaxAreaPathLen;
	void alignDescription(char* desc, char* aligned, int len, int prefixLen);
};

#endif
