#ifndef __ADRENALIN__COMMON__HEADER__
#define __ADRENALIN__COMMON__HEADER__

#include <windows.h>
#include <fstream.h>
#include "FTNStruc.hpp"

enum { ROUTE_NONE = 0, ROUTE_SEND = 1, ROUTE_RECEIVE = 2, ROUTE_BIDIRECT = 3 };

enum { ACTIVITY_USUAL, ACTIVITY_PASSIVE, ACTIVITY_UNAVAILABLE };

enum { MSGDATA_NONE, MSGDATA_COMMAND, MSGDATA_SUBSCRIBE, MSGDATA_UNSUBSCRIBE };

struct SAddrList {
    SFTNAddress  Addr;
    SAddrList   *Next;
};

struct SStringList {
    char        *String;
    SStringList *Next;
};

struct SMsgDataList {
    char         *Data;
    int           DataType;
    SMsgDataList *Next;
};

class CStringList {
public:
    CStringList();
    ~CStringList();
    void Free();
    void Add(char *s);
    SStringList *Strings;
private:
    SStringList *LastItem;
};

const LONG_DESC_PREFIX_SIZE = 20;

struct SGlobalVars {
    SFTNAddress   MainAddr;
    SFTNAddress  *AKAAddr;
    int           AKAAddrNumber;
    char          SysOp[36];
    char          InboundPath[MAX_PATH];
    char          OutboundPath[MAX_PATH];
    char          BinkOutboundPath[MAX_PATH];
    char          NetmailPath[MAX_PATH];
    char          BadTicsPath[MAX_PATH];
    char          NewTicsPath[MAX_PATH];
    char          AutoCreatedPath[MAX_PATH];
    char          AutoDescFileName[MAX_PATH];
    char          LongDescPrefix[LONG_DESC_PREFIX_SIZE+1];
    int           LongPaths;
    char        **Aliases;
    int           AliasesNumber;
    SMsgDataList *MsgData;
    ofstream      Log;
    int           HandleReplaces;
    int           HatchOriginMain;
    int           AllAKASeen;
    int           KillProcessedMail;
    int           ShowMustGoOn;
    int           LogMsgNames;
    char          FixFlagName[MAX_PATH];
    char          TossFlagName[MAX_PATH];
    char          HatchFlagName[MAX_PATH];
    bool	fCheckDomainInBSO;
    int		m_nForwardExpirationTime;	// days
    void FreeMsgData();
};

extern SGlobalVars GlobalVars;

#endif
