#ifndef __ADRENALIN__MISC__HEADER__
#define __ADRENALIN__MISC__HEADER__

#include <stdio.h>
#include <windows.h>

void GetCurrentDateTime(char *s);
void GetCurrentDateTimeY2K(char *s);

long GetFileNumber(char *s); // gets number of file with name <number>.<ext>

long GetFileNumberHex(char *s); /* same as above, but <number> is
                                   hexadecimal */

int GetNumberOfEnclosedNames(char *s); /* gets number of enclosed directory
                                          names, e.g. for D:\FIDO\OUTBOUND\
                                          it will be 3 */

int MakeDirStructure(char *s, int SkipNumber = 0); /* makes direcory structure,
                                                      but first skips
                                                      SkipNumber of
                                                      directory names */

long GetFreeDirNumber(char *FindFileMask); /* gets free number of file in
                                              directory
                                              mask is <DIR>\*.<EXT> */

long GetFreeDirNumberHex(char *FindFileMask); /* same as above, but checks
                                                 hexadecimal numbers */

long int GetFileSize(FILE *f);

int  IsAlpha(char *s);
void RemoveBoundaryQuotes(char *s);
int  GetOnBit(unsigned long bitarray);

int CheckMask(char *s, char *mask);
int IsMask(char *s);

int MoveFile(char *SourceFileName, char *DestFileName);
int CopyFile(char *SourceFileName, char *DestFileName);

void ConvertNameToShort(char *Src,char *Dest);

void StrNCpy(char *Dest, const char *Source, int Number);

void ConvertSoftCR(char *String);

void FormatSize(int size, char *buf); // 12345678 -> "12,345,678"

int CreateFileFlag(char *FlagName);

BOOL parseIntWithCommas(char* str, DWORD& d);

void	removeBoundarySpaces(char* source, char* dest);

int GetDays(WORD wDay, WORD wMonth, WORD wYear); 
// return date as number of days since 01 Jan 2000
// day: 1..31, month: 1..12, year: 0..99

#endif
