// changes log:
// 01.02.2000 21:41 added GetLastError method and szLastError field to CTic

#ifndef __ADRENALIN__TIC__HEADER__
#define __ADRENALIN__TIC__HEADER__

#include <windows.h>
#include <time.h>
#include "FTNStruc.hpp"
#include "Areas.hpp"
#include "BSO.hpp"

// ----------------------------------------------------------------------
// class CTicNamer intended to handle TIC file names. Directly speaking,
// it returns continuously free TIC number for files in desired directory
// ----------------------------------------------------------------------

class CTicNamer {
public:
    CTicNamer();
    CTicNamer(char *seekPath);
    ~CTicNamer();
    int  getFreeNumber();
    void printDebugInfo();
private:
    struct SNumberInterval {
        int number;
        int length;
    };
    SNumberInterval *intervals;
    int              intervalsCount;
    int              freeNumber;
    int              currentInterval;
    void resetFields(); // does reset of fields without freeing memory
    void freeFields();  // frees memory allocated for fields
    void readTICs(char *seekPath); // reads tic-files in seekPath directory and
                                   // calculates their numbers
    int  parseNumber(char *ticName);
};



class CTic {
public:
    CTic();
    ~CTic();
    int Read(char *TicFileName);
    void PrintInfo();
    SFTNAddress  Origin;
    SFTNAddress  From;
    SFTNAddress  To;
    char         Area[AREA_NAME_SIZE];
    char         AreaDesc[AREA_DESC_SIZE];
    char         File[MAX_PATH];
    char         FullName[MAX_PATH];
    char         Replaces[MAX_PATH];
    int          Size;
    char         PW[256];
    char         Desc[256];
    SAddrList   *SeenbyList, *LastSeenby;
    UINT         CRC32;
    SStringList *LDescList;
    int          Forward(SLink *Link, char *FilePath, SLinked *ForwardList);
    const char*	GetLastError() const { return (szLastError); } // returns last error string
private:
    char         Magic[MAX_PATH];
    time_t       Date;
    time_t       Release;
    char         Author[256];
    char         Source[256]; // author's address
    char         App[256];
    char         FromPwd[256];
    char         CreatedBy[256];
    SStringList *ViaList, *LastVia;
    SStringList *PathList, *LastPath;
    SStringList *UnknownList;

    CBSOManager  BSOManager;

    CTicNamer    ticNamer;
    
    int ParseAddr(char *s, SFTNAddress &Addr);
    void Free();

    char	szLastError[256];
};

#endif
